# mypy: disable-error-code="misc, override, no-redef"

import Boost.Python
import pxr.Ar
import pxr.Sdf
import pxr.Usd
import pxr.UsdGeom
from . import cameraArgs as cameraArgs, colorArgs as colorArgs, complexityArgs as complexityArgs, framesArgs as framesArgs, rendererArgs as rendererArgs
from typing import ClassVar

__MFB_FULL_PACKAGE_NAME: str

class FrameRecorder(Boost.Python.instance):
    __instance_size__: ClassVar[int] = ...
    def __init__(self, rendererPluginId: object = ..., gpuEnabled: bool = ..., renderSettingsPrimPath: pxr.Sdf.Path | str = ...) -> None: ...
    def GetCurrentRendererId(self) -> str: ...
    def Record(self, stage: pxr.Usd.Stage, usdCamera: pxr.UsdGeom.Camera, timeCode: pxr.Usd.TimeCode | float | pxr.Sdf.TimeCode, outputImagePath: str | pxr.Ar.ResolvedPath) -> bool: ...
    def SetCameraLightEnabled(self, arg2: bool) -> None: ...
    def SetColorCorrectionMode(self, arg2: str | pxr.Ar.ResolvedPath) -> None: ...
    def SetComplexity(self, arg2: float) -> None: ...
    def SetImageWidth(self, arg2: int) -> None: ...
    def SetIncludedPurposes(self, purposes: list[str] | list[pxr.Ar.ResolvedPath]) -> None: ...
    def SetRendererPlugin(self, arg2: str | pxr.Ar.ResolvedPath) -> bool: ...

def GetCameraAtPath(stage: pxr.Usd.Stage, cameraPath: pxr.Sdf.Path | str) -> pxr.UsdGeom.Camera: ...
