# mypy: disable-error-code="misc, override, no-redef"

import Boost.Python
import pxr.Ar
import pxr.Sdf
import pxr.Tf
import pxr.Usd
import pxr.UsdGeom
import typing
from _typeshed import Incomplete
from typing import Any, ClassVar, overload

__MFB_FULL_PACKAGE_NAME: str

class AssetPreviewsAPI(pxr.Usd.APISchemaBase):
    class Thumbnails(Boost.Python.instance):
        __instance_size__: ClassVar[int] = ...
        defaultImage: Incomplete
        def __init__(self, defaultImage: pxr.Sdf.AssetPath | str = ...) -> None: ...
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self) -> None: ...
    @staticmethod
    def Apply(prim: pxr.Usd.Prim) -> AssetPreviewsAPI: ...
    @staticmethod
    def CanApply(prim: pxr.Usd.Prim) -> _CanApplyResult: ...
    def ClearDefaultThumbnails(self) -> None: ...
    @staticmethod
    def Get(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> AssetPreviewsAPI: ...
    @overload
    @staticmethod
    def GetAssetDefaultPreviews(layerPath: str | pxr.Ar.ResolvedPath) -> AssetPreviewsAPI: ...
    @overload
    @staticmethod
    def GetAssetDefaultPreviews(layer: pxr.Sdf.Layer) -> AssetPreviewsAPI: ...
    def GetDefaultThumbnails(self) -> AssetPreviewsAPI.Thumbnails: ...
    @staticmethod
    def GetSchemaAttributeNames(includeInherited: bool = ...) -> list[str]: ...
    def SetDefaultThumbnails(self, thumbnails: AssetPreviewsAPI.Thumbnails) -> None: ...
    @staticmethod
    def _GetStaticTfType() -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...

class SpatialAudio(pxr.UsdGeom.Xformable):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def CreateAuralModeAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateEndTimeAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateFilePathAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateGainAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateMediaOffsetAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreatePlaybackModeAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateStartTimeAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    @staticmethod
    def Define(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> SpatialAudio: ...
    @staticmethod
    def Get(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> SpatialAudio: ...
    def GetAuralModeAttr(self) -> pxr.Usd.Attribute: ...
    def GetEndTimeAttr(self) -> pxr.Usd.Attribute: ...
    def GetFilePathAttr(self) -> pxr.Usd.Attribute: ...
    def GetGainAttr(self) -> pxr.Usd.Attribute: ...
    def GetMediaOffsetAttr(self) -> pxr.Usd.Attribute: ...
    def GetPlaybackModeAttr(self) -> pxr.Usd.Attribute: ...
    @staticmethod
    def GetSchemaAttributeNames(includeInherited: bool = ...) -> list[str]: ...
    def GetStartTimeAttr(self) -> pxr.Usd.Attribute: ...
    @staticmethod
    def _GetStaticTfType() -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...

class Tokens(Boost.Python.instance):
    AssetPreviewsAPI: ClassVar[str] = ...  # read-only
    SpatialAudio: ClassVar[str] = ...  # read-only
    auralMode: ClassVar[str] = ...  # read-only
    defaultImage: ClassVar[str] = ...  # read-only
    endTime: ClassVar[str] = ...  # read-only
    filePath: ClassVar[str] = ...  # read-only
    gain: ClassVar[str] = ...  # read-only
    loopFromStage: ClassVar[str] = ...  # read-only
    loopFromStart: ClassVar[str] = ...  # read-only
    loopFromStartToEnd: ClassVar[str] = ...  # read-only
    mediaOffset: ClassVar[str] = ...  # read-only
    nonSpatial: ClassVar[str] = ...  # read-only
    onceFromStart: ClassVar[str] = ...  # read-only
    onceFromStartToEnd: ClassVar[str] = ...  # read-only
    playbackMode: ClassVar[str] = ...  # read-only
    previewThumbnails: ClassVar[str] = ...  # read-only
    previewThumbnailsDefault: ClassVar[str] = ...  # read-only
    previews: ClassVar[str] = ...  # read-only
    spatial: ClassVar[str] = ...  # read-only
    startTime: ClassVar[str] = ...  # read-only
    thumbnails: ClassVar[str] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...

class _CanApplyResult(Boost.Python.instance):
    __instance_size__: ClassVar[int] = ...
    def __init__(self, arg2: bool, arg3: object) -> None: ...
    def __bool__(self) -> bool: ...
    def __eq__(self, other: object) -> bool: ...
    def __getitem__(self, arg2: int) -> Any: ...
    def __iter__(self) -> typing.Iterator[Any]: ...
    def __ne__(self, other: object) -> bool: ...
    @property
    def whyNot(self): ...
