# mypy: disable-error-code="misc, override, no-redef"

import pxr.Sdf as Sdf
import pxr.Sdr as Sdr
import pxr.Tf as Tf
import pxr.Usd as Usd
import pxr.UsdShade as UsdShade
import pxr.UsdUtils.constantsGroup
import pxr.Vt as Vt
from pxr.UsdUtils.constantsGroup import ConstantsGroup as ConstantsGroup
from typing import ClassVar

class PropertyDefiningKeys(pxr.UsdUtils.constantsGroup.ConstantsGroup):
    CONNECTABILITY: ClassVar[str] = ...
    INTERNAL_DISPLAY_GROUP: ClassVar[str] = ...
    NULL_VALUE: ClassVar[str] = ...
    PROPERTY_NS_PREFIX_OVERRIDE: ClassVar[str] = ...
    SDF_VARIABILITY_UNIFORM_STRING: ClassVar[str] = ...
    SHADER_ID: ClassVar[str] = ...
    USD_SUPPRESS_PROPERTY: ClassVar[str] = ...
    USD_VARIABILITY: ClassVar[str] = ...
    WIDGET: ClassVar[str] = ...
    _all: ClassVar[tuple] = ...

class SchemaDefiningKeys(pxr.UsdUtils.constantsGroup.ConstantsGroup):
    API_SCHEMAS_FOR_ATTR_PRUNING: ClassVar[str] = ...
    API_SCHEMA_AUTO_APPLY_TO: ClassVar[str] = ...
    API_SCHEMA_CAN_ONLY_APPLY_TO: ClassVar[str] = ...
    IS_USD_SHADE_CONTAINER: ClassVar[str] = ...
    PROVIDES_USD_SHADE_CONNECTABLE_API_BEHAVIOR: ClassVar[str] = ...
    REQUIRES_USD_SHADE_ENCAPSULATION: ClassVar[str] = ...
    SCHEMA_BASE: ClassVar[str] = ...
    SCHEMA_KIND: ClassVar[str] = ...
    SCHEMA_NAME: ClassVar[str] = ...
    SCHEMA_PROPERTY_NS_PREFIX_OVERRIDE: ClassVar[str] = ...
    TF_TYPENAME_SUFFIX: ClassVar[str] = ...
    TYPED_SCHEMA_FOR_ATTR_PRUNING: ClassVar[str] = ...
    _all: ClassVar[tuple] = ...

class SchemaDefiningMiscConstants(pxr.UsdUtils.constantsGroup.ConstantsGroup):
    API_SCHEMA_BASE: ClassVar[str] = ...
    API_STRING: ClassVar[str] = ...
    NodeDefAPI: ClassVar[str] = ...
    SINGLE_APPLY_SCHEMA: ClassVar[str] = ...
    TYPED_SCHEMA: ClassVar[str] = ...
    USD_SOURCE_TYPE: ClassVar[str] = ...
    _all: ClassVar[tuple] = ...

def UpdateSchemaWithSdrNode(schemaLayer, sdrNode, renderContext: str = ..., overrideIdentifier: str = ...): ...
def _CreateAttrSpecFromNodeAttribute(primSpec, prop, primDefForAttrPruning, schemaPropertyNSPrefixOverride, isSdrInput: bool = ...): ...
def _IsNSPrefixConnectableAPICompliant(nsPrefix): ...
