# mypy: disable-error-code="misc, override, no-redef"

import Boost.Python
import pxr.Ar
import pxr.Sdf
import pxr.Tf
import pxr.Usd
import pxr.UsdGeom
from typing import Any, ClassVar, overload

__MFB_FULL_PACKAGE_NAME: str

class Field3DAsset(FieldAsset):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def CreateFieldDataTypeAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateFieldPurposeAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    @staticmethod
    def Define(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> Field3DAsset: ...
    @staticmethod
    def Get(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> Field3DAsset: ...
    def GetFieldDataTypeAttr(self) -> pxr.Usd.Attribute: ...
    def GetFieldPurposeAttr(self) -> pxr.Usd.Attribute: ...
    @staticmethod
    def GetSchemaAttributeNames(includeInherited: bool = ...) -> list[str]: ...
    @staticmethod
    def _GetStaticTfType() -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...

class FieldAsset(FieldBase):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def CreateFieldDataTypeAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateFieldIndexAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateFieldNameAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateFilePathAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateVectorDataRoleHintAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    @staticmethod
    def Get(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> FieldAsset: ...
    def GetFieldDataTypeAttr(self) -> pxr.Usd.Attribute: ...
    def GetFieldIndexAttr(self) -> pxr.Usd.Attribute: ...
    def GetFieldNameAttr(self) -> pxr.Usd.Attribute: ...
    def GetFilePathAttr(self) -> pxr.Usd.Attribute: ...
    @staticmethod
    def GetSchemaAttributeNames(includeInherited: bool = ...) -> list[str]: ...
    def GetVectorDataRoleHintAttr(self) -> pxr.Usd.Attribute: ...
    @staticmethod
    def _GetStaticTfType() -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...

class FieldBase(pxr.UsdGeom.Xformable):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self) -> None: ...
    @staticmethod
    def Get(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> FieldBase: ...
    @staticmethod
    def GetSchemaAttributeNames(includeInherited: bool = ...) -> list[str]: ...
    @staticmethod
    def _GetStaticTfType() -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...

class OpenVDBAsset(FieldAsset):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def CreateFieldClassAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateFieldDataTypeAttr(self, defaultValue: Any = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    @staticmethod
    def Define(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> OpenVDBAsset: ...
    @staticmethod
    def Get(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> OpenVDBAsset: ...
    def GetFieldClassAttr(self) -> pxr.Usd.Attribute: ...
    def GetFieldDataTypeAttr(self) -> pxr.Usd.Attribute: ...
    @staticmethod
    def GetSchemaAttributeNames(includeInherited: bool = ...) -> list[str]: ...
    @staticmethod
    def _GetStaticTfType() -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...

class Tokens(Boost.Python.instance):
    Color: ClassVar[str] = ...  # read-only
    Field3DAsset: ClassVar[str] = ...  # read-only
    FieldAsset: ClassVar[str] = ...  # read-only
    FieldBase: ClassVar[str] = ...  # read-only
    None_: ClassVar[str] = ...  # read-only
    Normal: ClassVar[str] = ...  # read-only
    OpenVDBAsset: ClassVar[str] = ...  # read-only
    Point: ClassVar[str] = ...  # read-only
    Vector: ClassVar[str] = ...  # read-only
    Volume: ClassVar[str] = ...  # read-only
    bool_: ClassVar[str] = ...  # read-only
    double2: ClassVar[str] = ...  # read-only
    double3: ClassVar[str] = ...  # read-only
    double_: ClassVar[str] = ...  # read-only
    field: ClassVar[str] = ...  # read-only
    fieldClass: ClassVar[str] = ...  # read-only
    fieldDataType: ClassVar[str] = ...  # read-only
    fieldIndex: ClassVar[str] = ...  # read-only
    fieldName: ClassVar[str] = ...  # read-only
    fieldPurpose: ClassVar[str] = ...  # read-only
    filePath: ClassVar[str] = ...  # read-only
    float2: ClassVar[str] = ...  # read-only
    float3: ClassVar[str] = ...  # read-only
    float_: ClassVar[str] = ...  # read-only
    fogVolume: ClassVar[str] = ...  # read-only
    half: ClassVar[str] = ...  # read-only
    half2: ClassVar[str] = ...  # read-only
    half3: ClassVar[str] = ...  # read-only
    int2: ClassVar[str] = ...  # read-only
    int3: ClassVar[str] = ...  # read-only
    int64: ClassVar[str] = ...  # read-only
    int_: ClassVar[str] = ...  # read-only
    levelSet: ClassVar[str] = ...  # read-only
    mask: ClassVar[str] = ...  # read-only
    matrix3d: ClassVar[str] = ...  # read-only
    matrix4d: ClassVar[str] = ...  # read-only
    quatd: ClassVar[str] = ...  # read-only
    staggered: ClassVar[str] = ...  # read-only
    string: ClassVar[str] = ...  # read-only
    uint: ClassVar[str] = ...  # read-only
    unknown: ClassVar[str] = ...  # read-only
    vectorDataRoleHint: ClassVar[str] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...

class Volume(pxr.UsdGeom.Gprim):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def BlockFieldRelationship(self, name: str | pxr.Ar.ResolvedPath) -> bool: ...
    def CreateFieldRelationship(self, name: str | pxr.Ar.ResolvedPath, fieldPath: pxr.Sdf.Path | str) -> bool: ...
    @staticmethod
    def Define(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> Volume: ...
    @staticmethod
    def Get(stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> Volume: ...
    def GetFieldPath(self, name: str | pxr.Ar.ResolvedPath) -> pxr.Sdf.Path: ...
    def GetFieldPaths(self) -> dict: ...
    @staticmethod
    def GetSchemaAttributeNames(includeInherited: bool = ...) -> list[str]: ...
    def HasFieldRelationship(self, name: str | pxr.Ar.ResolvedPath) -> bool: ...
    @staticmethod
    def _GetStaticTfType() -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...
