# mypy: disable-error-code="misc, override, no-redef"

import PySide6.QtCore
import pxr.Gf as Gf
import pxr.Tf as Tf
from _typeshed import Incomplete
from typing import ClassVar

DEBUG_CLIPPING: str

class FreeCamera(PySide6.QtCore.QObject):
    defaultFar: ClassVar[int] = ...
    defaultNear: ClassVar[int] = ...
    maxGoodZResolution: ClassVar[float] = ...
    maxSafeZResolution: ClassVar[float] = ...
    signalFrustumChanged: ClassVar[PySide6.QtCore.Signal] = ...
    signalFrustumSettingsChanged: ClassVar[PySide6.QtCore.Signal] = ...
    staticMetaObject: ClassVar[PySide6.QtCore.QMetaObject] = ...
    aspectRatio: Incomplete
    center: Incomplete
    dist: Incomplete
    focalLength: Incomplete
    fov: Incomplete
    horizontalAperture: Incomplete
    orthographic: Incomplete
    overrideFar: Incomplete
    overrideNear: Incomplete
    rotPhi: Incomplete
    rotTheta: Incomplete
    verticalAperture: Incomplete
    def __init__(self, isZUp, fov: float = ..., aspectRatio: float = ..., overrideNear: Incomplete | None = ..., overrideFar: Incomplete | None = ...) -> None: ...
    def AdjustDistance(self, scaleFactor): ...
    def ComputePixelsToWorldFactor(self, viewportHeight): ...
    @staticmethod
    def FromGfCamera(gfCamera, isZUp): ...
    def PanTilt(self, dPan, dTilt): ...
    def Truck(self, deltaRight, deltaUp): ...
    def Tumble(self, dTheta, dPhi): ...
    def Walk(self, dForward, dRight): ...
    def _pullFromCameraTransform(self): ...
    def _pushToCameraTransform(self): ...
    def _rangeOfBoxAlongRay(self, camRay, bbox, debugClipping: bool = ...): ...
    def clone(self): ...
    def computeGfCamera(self, stageBBox, autoClip: bool = ...): ...
    def frameSelection(self, selBBox, frameFit): ...
    def resetClippingPlanes(self): ...
    def setClippingPlanes(self, stageBBox): ...
    def setClosestVisibleDistFromPoint(self, point): ...
    @property
    def far(self): ...
    @property
    def near(self): ...
