# mypy: disable-error-code="misc, override, no-redef"

import pxr.Plug as Plug
import pxr.Tf as Tf
from _typeshed import Incomplete
from pxr.Tf import PluginContainerTfType as PluginContainerTfType

class CommandPlugin:
    def __init__(self, name, displayName, callback, description, usdviewApi) -> None: ...
    def run(self): ...
    @property
    def description(self): ...
    @property
    def displayName(self): ...
    @property
    def name(self): ...

class DeferredImport:
    def __init__(self, moduleName, packageName: Incomplete | None = ...) -> None: ...
    def __getattr__(self, attr): ...

class DuplicateCommandPlugin(Exception):
    def __init__(self, name) -> None: ...

class PluginContainer:
    def configureView(self, plugRegistry, plugUIBuilder): ...
    def deferredImport(self, moduleName): ...
    def registerPlugins(self, plugRegistry, plugCtx): ...

class PluginMenu:
    def __init__(self, qMenu) -> None: ...
    def addItem(self, commandPlugin, shortcut: Incomplete | None = ...): ...
    def addSeparator(self): ...
    def findOrCreateSubmenu(self, menuName): ...

class PluginRegistry:
    def __init__(self, usdviewApi) -> None: ...
    def getCommandPlugin(self, name): ...
    def registerCommandPlugin(self, name, displayName, callback, description: str = ...): ...

class PluginUIBuilder:
    def __init__(self, mainWindow) -> None: ...
    def findOrCreateMenu(self, menuName): ...

def loadPlugins(usdviewApi, mainWindow): ...
